// Copyrigth (C) 2012 - embedded.toolbox@gmail.com

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// Source code of this file is mainly taken from :
// - https://github.com/AutonomyLab/ardrone_autonomy
//


#ifndef ARDRONE_VIDEO_DRIVER_H_
#define ARDRONE_VIDEO_DRIVER_H_


/**
 * Includes
 */
#ifndef FFMPEG_SUPPORT
#define FFMPEG_SUPPORT
#endif

#ifndef USE_LINUX
#define USE_LINUX
#endif

#include <stdint.h>
#ifndef UINT64_C
#define UINT64_C(c) (c ## ULL)
#endif

#include <config.h>
    
#include <ardrone_tool/ardrone_version.h>
#include <ardrone_tool/ardrone_tool.h>
#include <ardrone_tool/ardrone_tool_configuration.h>  
#include <ardrone_tool/Com/config_com.h>
#include <ardrone_tool/UI/ardrone_input.h>
#include <ardrone_tool/Video/video_com_stage.h>
#include <ardrone_tool/Control/ardrone_control.h>
#include <ardrone_tool/Navdata/ardrone_navdata_client.h>

#include <ardrone_tool/Video/video_stage.h>
#include <ardrone_tool/Video/video_recorder_pipeline.h>
#include <ardrone_tool/Video/video_stage_latency_estimation.h>

#include "ardrone_driver.h"


/**
 * Constants
 */
#define NB_DRIVER_POST_STAGES   10

// The maximum memory allocation
#define MAX_STREAM_WIDTH 640
#define MAX_STREAM_HEIGHT 360

/** Drone 1 */

// Drone 1 Static Stream Size & PIP Stuff
// PIP is not supported in AR-Drone SDK 2.0
#define D1_STREAM_WIDTH 320
#define D1_STREAM_HEIGHT 240

//Vertical Camera standalone
#define D1_VERTSTREAM_WIDTH 174
#define D1_VERTSTREAM_HEIGHT 144

// Vertical Camera in PIP
#define D1_MODE2_PIP_WIDTH 87 //Huh?
#define D1_MODE2_PIP_HEIGHT 72

//Horizontal Camera in PIP
#define D1_MODE3_PIP_WIDTH 58
#define D1_MODE3_PIP_HEIGHT 42

/** Drone 2 */

// NO PIP, Both camera streams provide the same reseloution: Simple!
#define D2_STREAM_WIDTH 640
#define D2_STREAM_HEIGHT 360


/**
 * Structures
 */
extern const vp_api_stage_funcs_t vp_stages_export_funcs;


/**
 * Public fonctions
 */

/**
 *
 */
void ardrone_video_init(void);

/**
 *
 */
void ardrone_video_shutdown(void);

/**
 *
 */
rtm_error_t ardrone_video_get_image(double ** data_p, int * width, int * heigth, int number_of_colors);

/**
 *
 */
rtm_error_t ardrone_video_get_raw_image(uint8_t ** data_p, int * width, int * height);

#endif // ARDRONE_VIDEO_DRIVER_H_

